Loading...
Searching...
No Matches
Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV > Struct Template Reference

The primary variable and equation indices for the black-oil model. More...

`#include <blackoiltwophaseindices.hh>`

## Static Public Attributes

static constexpr bool | oilEnabled = disabledCanonicalCompIdx != 0
| Is phase enabled or not.
static constexpr bool | waterEnabled = disabledCanonicalCompIdx != 1
static constexpr bool | gasEnabled = disabledCanonicalCompIdx != 2
static constexpr bool | enableSolvent = numSolventsV > 0
| Are solvents involved?
static constexpr bool | enableExtbo = numExtbosV > 0
| Is extbo invoked?
static constexpr bool | enablePolymer = numPolymersV > 0
| Are polymers involved?
static constexpr bool | enableEnergy = numEnergyV > 0
| Shall energy be conserved?
static constexpr bool | enableMICP = false
| MICP only available for one phase indices.
static constexpr bool | enableBiofilm = numBioCompV > 0
| Are biofilms involved?
static constexpr int | numSolvents = enableSolvent ? numSolventsV : 0
| Number of solvent components to be considered.
static constexpr int | numExtbos = enableExtbo ? numExtbosV : 0
| Number of components to be considered for extbo.
static constexpr int | numPolymers = enablePolymer ? numPolymersV : 0
| Number of polymer components to be considered.
static constexpr int | numEnergy = enableEnergy ? numEnergyV : 0
| Number of energy equations to be considered.
static constexpr int | numFoam = enableFoam? 1 : 0
| Number of foam equations to be considered.
static constexpr int | numBrine = enableBrine? 1 : 0
| Number of salt equations to be considered.
static constexpr int | numBioComp = enableBiofilm ? numBioCompV : 0
| Number of biofilm equations to be considered.
static constexpr int | numBioInWat = enableBiofilm ? 1 : 0
| Number of biocomponents in the water phase.
static constexpr int | numPhases = 2
| The number of fluid phases.
static constexpr int | numEq
| The number of equations.
static constexpr int | waterSwitchIdx = waterEnabled ? PVOffset + 0 : -10000
| Index of the switching variable which determines the composistion of the water phase.
static constexpr int | pressureSwitchIdx = waterEnabled ? PVOffset + 1 : PVOffset + 0
| Index of the switching variable which determines the pressure.
static constexpr int | compositionSwitchIdx = (gasEnabled && oilEnabled) ? PVOffset + 1 : -10000
| Index of the switching variable which determines the composition of the hydrocarbon phases.
static constexpr int | solventSaturationIdx
| Index of the primary variable for the first solvent.
static constexpr int | zFractionIdx
| Index of the primary variable for the first extbo component.
static constexpr int | polymerConcentrationIdx
| Index of the primary variable for the first polymer.
static constexpr int | polymerMoleWeightIdx
| Index of the primary variable for the second polymer primary variable (molecular weight).
static constexpr int | microbialConcentrationIdx
| Index of the primary variable for the first microbial component.
static constexpr int | biofilmVolumeFractionIdx
| Index of the primary variable for the biofilm component.
static constexpr int | oxygenConcentrationIdx = -1000
| MICP only available for one phase indices.
static constexpr int | ureaConcentrationIdx = -1000
static constexpr int | calciteVolumeFractionIdx = -1000
static constexpr int | foamConcentrationIdx
| Index of the primary variable for the foam.
static constexpr int | saltConcentrationIdx
| Index of the primary variable for the salt.
static constexpr int | temperatureIdx
| Index of the primary variable for temperature.
static constexpr int | conti0EqIdx = PVOffset + 0
| Index of the continuity equation of the first phase.
static constexpr int | contiSolventEqIdx
| Index of the continuity equation for the first solvent component.
static constexpr int | contiZfracEqIdx
| Index of the continuity equation for the first extbo component.
static constexpr int | contiPolymerEqIdx
| Index of the continuity equation for the first polymer component.
static constexpr int | contiPolymerMWEqIdx
| Index of the continuity equation for the second polymer component (molecular weight).
static constexpr int | contiMicrobialEqIdx
| Index of the continuity equation for the first microbial component.
static constexpr int | contiBiofilmEqIdx
| Index of the continuity equation for the biofilm component.
static constexpr int | contiOxygenEqIdx = -1000
| MICP only available for one phase indices.
static constexpr int | contiUreaEqIdx = -1000
static constexpr int | contiCalciteEqIdx = -1000
static constexpr int | contiFoamEqIdx
| Index of the continuity equation for the foam component.
static constexpr int | contiBrineEqIdx
| Index of the continuity equation for the salt component.
static constexpr int | contiEnergyEqIdx
| Index of the continuity equation for energy.

## Detailed Description

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>
struct Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >

The primary variable and equation indices for the black-oil model.

## Member Data Documentation

## biofilmVolumeFractionIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::biofilmVolumeFractionIdx

static constexpr

Initial value:
=
enableBiofilm ? PVOffset + numPhases + numSolvents + 1 : -1000
Opm::BlackOilTwoPhaseIndices::enableBiofilm
static constexpr bool enableBiofilm
Are biofilms involved?
Definition blackoiltwophaseindices.hh:74
Opm::BlackOilTwoPhaseIndices::numPhases
static constexpr int numPhases
The number of fluid phases.
Definition blackoiltwophaseindices.hh:101
Opm::BlackOilTwoPhaseIndices::numSolvents
static constexpr int numSolvents
Number of solvent components to be considered.
Definition blackoiltwophaseindices.hh:77

Index of the primary variable for the biofilm component.

## compositionSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::compositionSwitchIdx = (gasEnabled && oilEnabled) ? PVOffset + 1 : -10000

static constexpr

Index of the switching variable which determines the composition of the hydrocarbon phases.

Note
  For two-phase water oil and water gas models this is disabled.

## contiBiofilmEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiBiofilmEqIdx

static constexpr

Initial value:
=
enableBiofilm ? PVOffset + numPhases + numSolvents + 1 : -1000

Index of the continuity equation for the biofilm component.

## contiBrineEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiBrineEqIdx

static constexpr

Initial value:
=
enableBrine ? PVOffset + numPhases + numSolvents + numPolymers + numBioComp + numFoam : -1000
Opm::BlackOilOnePhaseIndices::numPolymers
static constexpr int numPolymers
Number of polymer components to be considered.
Definition blackoilonephaseindices.hh:83
Opm::BlackOilOnePhaseIndices::numPhases
static constexpr int numPhases
The number of fluid phases.
Definition blackoilonephaseindices.hh:95
Opm::BlackOilOnePhaseIndices::numSolvents
static constexpr int numSolvents
Number of solvent components to be considered.
Definition blackoilonephaseindices.hh:77
Opm::BlackOilOnePhaseIndices::numFoam
static constexpr int numFoam
Number of foam equations to be considered.
Definition blackoilonephaseindices.hh:89
Opm::BlackOilTwoPhaseIndices::numBioComp
static constexpr int numBioComp
Number of biofilm equations to be considered.
Definition blackoiltwophaseindices.hh:95

Index of the continuity equation for the salt component.

## contiEnergyEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiEnergyEqIdx

static constexpr

Initial value:
=
enableEnergy ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numBioComp + numFoam + numBrine: -1000
Opm::BlackOilOnePhaseIndices::numBrine
static constexpr int numBrine
Number of salt equations to be considered.
Definition blackoilonephaseindices.hh:92
Opm::BlackOilOnePhaseIndices::enableEnergy
static constexpr bool enableEnergy
Shall energy be conserved?
Definition blackoilonephaseindices.hh:68
Opm::BlackOilOnePhaseIndices::numExtbos
static constexpr int numExtbos
Number of components to be considered for extbo.
Definition blackoilonephaseindices.hh:80

Index of the continuity equation for energy.

## contiFoamEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiFoamEqIdx

static constexpr

Initial value:
=
enableFoam ? PVOffset + numPhases + numSolvents + numPolymers + numBioComp : -1000

Index of the continuity equation for the foam component.

## contiMicrobialEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiMicrobialEqIdx

static constexpr

Initial value:
=
enableBiofilm ? PVOffset + numPhases + numSolvents : -1000

Index of the continuity equation for the first microbial component.

## contiPolymerEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiPolymerEqIdx

static constexpr

Initial value:
=
enablePolymer ? PVOffset + numPhases + numSolvents : -1000
Opm::BlackOilOnePhaseIndices::enablePolymer
static constexpr bool enablePolymer
Are polymers involved?
Definition blackoilonephaseindices.hh:65

Index of the continuity equation for the first polymer component.

## contiPolymerMWEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiPolymerMWEqIdx

static constexpr

Initial value:
=
numPolymers > 1 ? contiPolymerEqIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::contiPolymerEqIdx
static constexpr int contiPolymerEqIdx
Index of the continuity equation for the first polymer component.
Definition blackoilonephaseindices.hh:201

Index of the continuity equation for the second polymer component (molecular weight).

## contiSolventEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiSolventEqIdx

static constexpr

Initial value:
=
enableSolvent ? PVOffset + numPhases : -1000
Opm::BlackOilOnePhaseIndices::enableSolvent
static constexpr bool enableSolvent
Are solvents involved?
Definition blackoilonephaseindices.hh:59

Index of the continuity equation for the first solvent component.

## contiZfracEqIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::contiZfracEqIdx

static constexpr

Initial value:
=
enableExtbo ? PVOffset + numPhases + numSolvents : -1000
Opm::BlackOilOnePhaseIndices::enableExtbo
static constexpr bool enableExtbo
Is extbo invoked?
Definition blackoilonephaseindices.hh:62

Index of the continuity equation for the first extbo component.

## foamConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::foamConcentrationIdx

static constexpr

Initial value:
=
enableFoam ? PVOffset + numPhases + numSolvents + numPolymers + numBioComp : -1000

Index of the primary variable for the foam.

## microbialConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::microbialConcentrationIdx

static constexpr

Initial value:
=
enableBiofilm ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first microbial component.

## numEq

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::numEq

static constexpr

Initial value:
= numPhases + numSolvents + numExtbos + numPolymers +
numEnergy + numFoam + numBrine + numBioComp
Opm::BlackOilOnePhaseIndices::numEnergy
static constexpr int numEnergy
Number of energy equations to be considered.
Definition blackoilonephaseindices.hh:86

The number of equations.

## polymerConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::polymerConcentrationIdx

static constexpr

Initial value:
=
enablePolymer ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first polymer.

## polymerMoleWeightIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::polymerMoleWeightIdx

static constexpr

Initial value:
=
numPolymers > 1 ? polymerConcentrationIdx + 1 : -1000
Opm::BlackOilOnePhaseIndices::polymerConcentrationIdx
static constexpr int polymerConcentrationIdx
Index of the primary variable for the first polymer.
Definition blackoilonephaseindices.hh:146

Index of the primary variable for the second polymer primary variable (molecular weight).

## pressureSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::pressureSwitchIdx = waterEnabled ? PVOffset + 1 : PVOffset + 0

static constexpr

Index of the switching variable which determines the pressure.

Depending on the phases present, this variable is either interpreted as the pressure of the oil phase, gas phase (if no oil) or water phase (if only water)

## saltConcentrationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::saltConcentrationIdx

static constexpr

Initial value:
=
enableBrine ? PVOffset + numPhases + numSolvents + numPolymers + numBioComp + numFoam : -1000

Index of the primary variable for the salt.

## solventSaturationIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::solventSaturationIdx

static constexpr

Initial value:
=
enableSolvent ? PVOffset + numPhases : -1000

Index of the primary variable for the first solvent.

## temperatureIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::temperatureIdx

static constexpr

Initial value:
=
enableEnergy ? PVOffset + numPhases + numSolvents + numExtbos + numPolymers + numBioComp + numFoam + numBrine : - 1000

Index of the primary variable for temperature.

## waterSwitchIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::waterSwitchIdx = waterEnabled ? PVOffset + 0 : -10000

static constexpr

Index of the switching variable which determines the composistion of the water phase.

Depending on the phases present, this variable is either interpreted as water saturation or vapporized water in gas phase

Note
  For two-phase gas-oil models this is disabled.

## zFractionIdx

template<unsigned numSolventsV, unsigned numExtbosV, unsigned numPolymersV, unsigned numEnergyV, bool enableFoam, bool enableBrine, unsigned PVOffset, unsigned disabledCanonicalCompIdx, unsigned numBioCompV>

int Opm::BlackOilTwoPhaseIndices< numSolventsV, numExtbosV, numPolymersV, numEnergyV, enableFoam, enableBrine, PVOffset, disabledCanonicalCompIdx, numBioCompV >::zFractionIdx

static constexpr

Initial value:
=
enableExtbo ? PVOffset + numPhases + numSolvents : -1000

Index of the primary variable for the first extbo component.

The documentation for this struct was generated from the following file:

- opm/models/blackoil/blackoiltwophaseindices.hh